﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
namespace pac8026WNet
{
    public class pac8026W
    {
        private class ICPDAS
        {
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_GetLibVersion")]
            public static extern Int16 pac_i8026W_GetLibVersion();
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_GetLibDate")]
            public static extern void pac_i8026W_GetLibDate(byte[] libDate);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_GetFirmwareVer")]
            public static extern Int16 pac_i8026W_GetFirmwareVer(int Slot);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_Init")]
            public static extern Int16 pac_i8026W_Init(int Slot);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_WriteDO")]
            public static extern void pac_i8026W_WriteDO(int slot, Int16 doVal);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_WriteDOBit")]
            public static extern void pac_i8026W_WriteDOBit(int slot, int chIndex, Int16 bitVal);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_ReadDIO")]
            public static extern Int16 pac_i8026W_ReadDIO(int slot, ref Int16 diVal, ref Int16 doVal, byte[] diBitArr, byte[] doBitArr);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_WriteAO")]
            public static extern Int16 pac_i8026W_WriteAO(int slot, int chIndex, Int16 gain, float aoData);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_WriteAOHex")]
            public static extern Int16 pac_i8026W_WriteAOHex(int slot, int chIndex, Int16 gain, Int16 hexData);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_ReadbackAO")]
            public static extern Int16 pac_i8026W_ReadbackAO(int slot, int chIndex, ref float fVal);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_ReadbackAOHex")]
            public static extern Int16 pac_i8026W_ReadbackAOHex(int slot, int chIndex, ref Int16 hVal);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_ReadAO_GainOffset")]
            public static extern void pac_i8026W_ReadAO_GainOffset(int slot, int chIndex, Int16 gain, ref UInt16 gainValue, ref Int16 offsetValue);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_ReadAIHex")]
            public static extern Int16 pac_i8026W_ReadAIHex(int slot, int chIndex, Int16 gain, ref Int16 hVal);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_ReadAI")]
            public static extern Int16 pac_i8026W_ReadAI(int slot, int chIndex, short gain, ref float fVal);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_ReadAIGainOffset")]
            public static extern Int16 pac_i8026W_ReadAIGainOffset(int slot, int ch, Int16 gain, ref UInt16 gainValue, ref Int16 offsetValue);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "pac_i8026W_Set_AVGCnt")]
            public static extern void pac_i8026W_Set_AVGCnt(int slot, UInt16 cnt);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "outB")]
            public static extern void outB(int slot, short offset, byte v);
            [DllImport("pac_i8026W_UWP_x64.dll", EntryPoint = "inB")]
            public static extern byte inB(int slot, short offset);
        }
        public static Int16 LibVersion()
        {
            return ICPDAS.pac_i8026W_GetLibVersion();
        }
        public static Int16 FirmwareVersion(int slot)
        {
            return ICPDAS.pac_i8026W_GetFirmwareVer(slot);
        }
        public static string LibDate()
        {
            byte[] libDate = new byte[32];
            ICPDAS.pac_i8026W_GetLibDate(libDate);
            return AscArr2Str(libDate);
        }
        public static Int16 Init(int slot)
        {
            return ICPDAS.pac_i8026W_Init(slot);
        }
        private static string AscArr2Str(byte[] b)
        {
            return System.Text.UnicodeEncoding.Unicode.GetString(
            System.Text.ASCIIEncoding.Convert(System.Text.Encoding.ASCII,
            System.Text.Encoding.Unicode, b), 0, b.Length);
        }
        public static string Arr2Str(byte[] buffer)
        {
            return (new UnicodeEncoding()).GetString(buffer, 0, buffer.Length);
        }
        public static void WriteDO(int slot, Int16 doVal)
        {
            ICPDAS.pac_i8026W_WriteDO(slot, doVal);
        }
        public static void outp(int slot, Int16 offset, byte data)
        {
            ICPDAS.outB(slot, offset, data);
        }
        public static byte inp(int slot, Int16 offset)
        {
            return ICPDAS.inB(slot, offset);
        }
        public static void WriteDOBit(int slot, int chIndex, Int16 bitVal)
        {
            ICPDAS.pac_i8026W_WriteDOBit(slot, chIndex, bitVal);
        }
        public static Int16 ReadDIO(int slot, ref Int16 diVal, ref Int16 doVal, byte[] diBitArr, byte[] doBitArr)
        {
            return ICPDAS.pac_i8026W_ReadDIO(slot, ref  diVal, ref  doVal, diBitArr, doBitArr);
        }
        public static Int16 WriteAO(int slot, int chIndex, Int16 gain, float aoData)
        {
            return ICPDAS.pac_i8026W_WriteAO(slot, chIndex, gain, aoData);
        }
        public static Int16 WriteAOHex(int slot, int chIndex, Int16 gain, Int16 hexData)
        {
            return ICPDAS.pac_i8026W_WriteAOHex(slot, chIndex, gain, hexData);
        }
        public static Int16 AOReadback(int slot, int chIndex, ref float fVal)
        {
            return ICPDAS.pac_i8026W_ReadbackAO(slot, chIndex, ref fVal);
        }
        public static Int16 AOHexReadback(int slot, int chIndex, ref Int16 hVal)
        {
            return ICPDAS.pac_i8026W_ReadbackAOHex(slot, chIndex, ref hVal);
        }
        public static void ReadAO_GainOffset(int slot, int chIndex, Int16 gain, ref UInt16 gainValue, ref Int16 offsetValue)
        {
            ICPDAS.pac_i8026W_ReadAO_GainOffset(slot, chIndex, gain, ref  gainValue, ref  offsetValue);
        }
        public static Int16 ReadAIGainOffset(int slot, int ch, Int16 gain, ref UInt16 gainValue, ref Int16 offsetValue)
        {
            return ICPDAS.pac_i8026W_ReadAIGainOffset(slot, ch, gain, ref  gainValue, ref offsetValue);
        }
        public static Int16 ReadAIHex(int slot, int chIndex, Int16 gain, ref Int16 hVal)
        {
            return ICPDAS.pac_i8026W_ReadAIHex(slot, chIndex, gain, ref hVal);
        }
        public static Int16 ReadAI(int slot, int chIndex, Int16 gain, ref float fVal)
        {
            return ICPDAS.pac_i8026W_ReadAI(slot, chIndex, gain, ref fVal);
        }
    }
}