﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x404

namespace i8026W_Basic_Info_Csharp
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class MainPage : Page
    {
        Int16 slot = 0;
        TextBox[] AI_txt;
        public MainPage()
        {
            this.InitializeComponent();
            Library_ver_txt.Text = String.Format("{0:X4}", pac8026WNet.pac8026W.LibVersion());
            Library_date_txt.Text = pac8026WNet.pac8026W.LibDate();
            AI_txt = new TextBox[6] { AI0_txt, AI1_txt, AI2_txt, AI3_txt, AI4_txt, AI5_txt };
        }

        private void slot_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            slot = (Int16)slot_cbx.SelectedIndex;
            if (pac8026WNet.pac8026W.Init(slot) == 0)
            {
                FW_ver_txt.Text = String.Format("{0:X4}", pac8026WNet.pac8026W.FirmwareVersion(slot));
                Status_txt.Text = "Init OK!!";
            }
            else
            {
                Status_txt.Text = "Init Failed!!";
            }
        }

        private void Read_btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 ch = 0;
            float fval = 0;
            for (ch = 0; ch < 6; ++ch)
            {
                pac8026WNet.pac8026W.ReadAI(slot, ch, (Int16)AI_Range_cbx.SelectedIndex, ref fval);
                AI_txt[ch].Text = String.Format("{0:00.000}", fval);
            }
        }

        private void AO0_btn_Click(object sender, RoutedEventArgs e)
        {
            pac8026WNet.pac8026W.WriteAO(slot, 0, (Int16)AO0_Range_cbx.SelectedIndex, float.Parse(AO0_txt.Text));
        }

        private void AO1_btn_Click(object sender, RoutedEventArgs e)
        {
            pac8026WNet.pac8026W.WriteAO(slot, 1, (Int16)AO1_Range_cbx.SelectedIndex, float.Parse(AO1_txt.Text));
        }

        private void DO_btn_Click(object sender, RoutedEventArgs e)
        {
            pac8026WNet.pac8026W.WriteDO(slot, Int16.Parse(DO_txt.Text));
        }

        private void DIO_btn_Click(object sender, RoutedEventArgs e)
        {
            short doval = 0;
            short dival = 0;
            byte[] dobit = new byte[2];
            byte[] dibit = new byte[2];
            pac8026WNet.pac8026W.ReadDIO(slot,ref doval,ref dival, dobit, dibit);
        }

        private void Exit_btn_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Exit();
        }
    }
}